//
//  WMZSelectBtn.h
//  WMZSelectBtn
//
//  Created by wmz on 2018/11/2.
//  Copyright © 2018年 wmz. All rights reserved.
//

#import <UIKit/UIKit.h>
//点击回调block
typedef void (^SelectBtnClickBlock)(id anyID);

typedef enum : NSUInteger{
    BtnTypeNornal,            //默认样式
    BtnTypeImageRight,        //图右文左样式
}BtnType;

@interface WMZSelectBtn : UIView

@property(nonatomic,strong)NSString *nornalImage;         //未选中的图片   需设置默认图

@property(nonatomic,strong)NSString *selectImage;         //选中的图片     需设置默认图

@property(nonatomic,assign)CGFloat font;                  //文本字体大小 15

@property(nonatomic,strong)UIColor *textColor;            //文本颜色 默认浅灰色

@property(nonatomic,strong)UIColor *selectBackColor;      //背景颜色 默认橙色

@property(nonatomic,strong)UIColor *selectTextColor;      //文本选中颜色 默认黑色

@property(nonatomic,assign)CGFloat padding;               //图片和文本的间距 默认5

@property(nonatomic,assign)CGFloat leftOffset;            //标签的左间距 默认10

@property(nonatomic,assign)CGFloat rightOffset;           //标签的右间距 默认10

@property(nonatomic,assign)CGFloat fixOffset;             //标签的间距 默认10

@property(nonatomic,assign)CGFloat btnWidth;              //按钮宽度 默认20

@property(nonatomic,assign)CGFloat btnHeight;             //按钮高度 默认20

@property(nonatomic,assign)BOOL cancelFirstSelect;        //首个是否取消默认选中  默认NO

@property(nonatomic,assign)BOOL cancelSelect;             //是否能单个取消选中  默认NO

@property(nonatomic,assign)BOOL hideBtn;                  //是否隐藏按钮 默认NO

@property(nonatomic,assign)BOOL checkBox;                 //能否多选  默认NO

@property(nonatomic,strong)UIColor *btnViewColor;         //标签背景颜色  默认clearColor

@property(nonatomic,strong)id data;                       //显示的数据

@property(nonatomic,strong)id blockData;                  //点击回调的数据


/*
 * 初始化
 */
+ (instancetype)shareInstance;

/*
 * 封装标签 可带选择框或不带
 *
 * @param  type   类型
 * @param  view   父视图
 * @param  data   数据源
 * @param  frame  frame位置
 * @param  handle 点击的回调
 *
 */
- (WMZSelectBtn*)addFrameViewWithType:(BtnType)type
                                 Data:(id)data
                            SuperView:(id)view
                                frame:(CGRect)frame
                                click:(SelectBtnClickBlock)handle;


@end


