


//
//  WMZSelectBtn.m
//  WMZSelectBtn
//
//  Created by wmz on 2018/11/2.
//  Copyright © 2018年 wmz. All rights reserved.
//
#define WMZSelectBtn_WIDTH ([[UIScreen mainScreen] bounds].size.width)

#define WMZSelectBtn_HEIGHT ([[UIScreen mainScreen] bounds].size.height)

#define marginY 10
//#define marginX 10

#define backRadio 10

#import "WMZSelectBtn.h"
@interface WMZSelectBtn()
{
    //重写set方法需要
    NSString *_nornalImage;
    NSString *_selectImage;
    CGFloat _font;
    UIColor *_textColor;
    CGFloat _padding;
    CGFloat _leftOffset;
    CGFloat _rightOffset;
    CGFloat _fixOffset;
    BOOL _cancelFirstSelect;
    id _data;
    CGFloat _btnWidth;
    CGFloat _btnHeight;
    UIColor *_btnViewColor;
    BOOL _hideBtn;
    BOOL _checkBox;
    BOOL _cancelSelect;
    UIColor *_selectBackColor;
    UIColor *_selectTextColor;
    CGFloat marginX;
}
@property(nonatomic,strong)NSMutableArray *viewArr;       //btnView的数组

@property(nonatomic,assign)BtnType type;                  //类型

@property(nonatomic,copy)SelectBtnClickBlock handBlock;   //点击回调

@property(nonatomic,strong)UIView *parentView;            //父视图

@property(nonatomic,assign)CGFloat x;                     //self的frame的x

@property(nonatomic,assign)CGFloat y;                     //self的frame的y

@property(nonatomic,assign)CGFloat width;                 //self的frame的width

@property(nonatomic,assign)CGFloat height;                //self的frame的height

@property(nonatomic,strong)NSMutableArray *handBlockArr;  //复选的数组

@property(nonatomic,assign)CGFloat centerX;               //原来的中心

@end

@implementation WMZSelectBtn

/*
 * 初始化
 */
+ (WMZSelectBtn*)shareInstance{
    return [[self alloc]init];
}

/*
 * 封装标签 可带选择框或不带
 *
 * @param  type   类型
 * @param  view   父视图
 * @param  data   数据源
 * @param  frame  frame位置
 * @param  handle 点击的回调
 *
 */
- (WMZSelectBtn*)addFrameViewWithType:(BtnType)type
                                 Data:(id)data
                            SuperView:(id)view
                                frame:(CGRect)frame
                                click:(SelectBtnClickBlock)handle{
    return [self addMasonryViewWithType:type Data:data SuperView:view frame:frame click:handle];
}

/*
 * 封装标签实现方法
 *
 * @param  type   类型
 * @param  view   父视图
 * @param  data   数据源
 * @param  frame  frame位置
 * @param  handle 点击的回调
 *
 */
- (WMZSelectBtn*)addMasonryViewWithType:(BtnType)type Data:(id)data SuperView:(id)view frame:(CGRect)frame click:(SelectBtnClickBlock)handle{
    if (!view) {
        return self;
    }else{
        self.parentView = view;
    }
    self.type = type;
    
    if (handle) {
        self.handBlock = handle;
    }
    
    [view addSubview:self];

    if (frame.size.width!=0&&frame.size.height!=0) {
        self.frame = frame;
    }
    marginX = 5;
    if (!data&&![data isKindOfClass:[NSArray class]]&&![data isKindOfClass:[NSMutableArray class]]&&![data isKindOfClass:[NSString class]]) {
        NSLog(@"传入数据不规范");
    }else{
        self.data = data;
    }
    
    
    return self;
}

/*
 * 插入视图
 *
 * @param  data   数据源
 *
 */
- (void)insertViewToArrWithData:(id)data{
    
    if (self.viewArr.count>0) {
        for (UIView *view in self.viewArr){
            [view removeFromSuperview];
        }
        self.viewArr = [NSMutableArray new];
    }

    
    NSInteger tag = 1000;
    if (self.viewArr.count>0) {
        UIView *lastView = self.viewArr[self.viewArr.count-1];
        tag=lastView.tag+1;
    }
    
    if ([data isKindOfClass:[NSArray class]]||[data isKindOfClass:[NSMutableArray class]]) {
            UIView *tempView = nil;
            for (int i = 0; i<[data count]; i++) {
                UIView *view = nil;
                if (!tempView) {
                    view = [self getFrameBtnViewWithTitle:data[i] View:self tag:tag+i LastView:nil];
                }else{
                    view = [self getFrameBtnViewWithTitle:data[i] View:self tag:tag+i LastView:tempView];

                }
                tempView = view;
                [self.viewArr addObject:view];
            }
            if (tempView) {
                CGRect rect = self.frame;
                rect.size.height = tempView.frame.origin.y + tempView.frame.size.height;
                self.frame = rect;
            }
    }
    if ([data isKindOfClass:[NSString class]]) {
        UIView *tempView = [self getFrameBtnViewWithTitle:data View:self tag:tag LastView:nil];
        if (tempView) {
            [self.viewArr addObject:tempView];
            CGRect rect = self.frame;
            rect.size.height = tempView.frame.origin.y + tempView.frame.size.height;
            self.frame = rect;
        }
    }
    
    if (!self.cancelFirstSelect) {
        
        for (UIView *btnView in self.viewArr) {
            
            if (btnView.tag==1000) {
                [self selectView:btnView];
                break;
            }
        }
    }
    

    if (self.viewArr.count==1) {
        self.cancelSelect = YES;
    }
    
}

/*
 * 更新所有视图
 */
- (void)updateSubview{
    UIView *lastView = nil;
    for (int i = 0; i<self.viewArr.count; i++) {
        UIView *btnView = self.viewArr[i];
        UILabel *label = [btnView viewWithTag:111];
        UIButton *imageBtn = [btnView viewWithTag:222];
        CGFloat labelWidth = [self getWidthWithText:label.text height:self.btnHeight font:self.font];
        CGFloat viewWidth = labelWidth+(self.hideBtn?0.001f:self.btnWidth)+(self.hideBtn?0.001f:self.padding);
        
        [self updateUIWithTypeWithBtnView:imageBtn labelView:label withWidth:labelWidth];
        [self setRadio:self.btnHeight/2 withID:imageBtn];
        if (self.hideBtn) {
            imageBtn.hidden = YES;
        }else{
            imageBtn.hidden = NO;
        }
        
        if (!lastView) {
            btnView.frame = CGRectMake(self.leftOffset, 0, viewWidth+marginX*2, self.height);
        }else{
            if (CGRectGetMaxX(lastView.frame) + viewWidth + self.fixOffset + marginX*2 > self.width) {
                btnView.frame = CGRectMake(self.leftOffset, CGRectGetMaxY(lastView.frame)+marginY, viewWidth+marginX*2, self.height);
            }else{
                btnView.frame = CGRectMake(CGRectGetMaxX(lastView.frame)+self.fixOffset, lastView.frame.origin.y, viewWidth+marginX*2, self.height);
            }
        }
        [self setRadio:backRadio withID:btnView];
        lastView = btnView;
    }
    if (lastView) {
        CGRect rect = self.frame;
        rect.size.height = lastView.frame.origin.y + lastView.frame.size.height;
        self.frame = rect;
    }
   
}

/*
 * 构造标签视图
 *
 * @param  title     文本内如
 * @param  view      父视图
 * @param  tag       tag
 * @param  lastView  上一个视图
 *
 */
- (UIView*)getFrameBtnViewWithTitle:(NSString*)title View:(UIView*)view  tag:(NSInteger)tag LastView:(UIView*)lastView{
    UIView *btnView = [UIView new];
    if (!view) {
        return btnView;
    }
    btnView.backgroundColor = self.btnViewColor;
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(tapAction:)];
    btnView.userInteractionEnabled = YES;
    [btnView addGestureRecognizer:tap];
    btnView.tag = tag;
    
    CGFloat labelWidth = [self getWidthWithText:title height:self.btnHeight font:self.font];
    CGFloat viewWidth = labelWidth+(self.hideBtn?0.001f:self.btnWidth)+(self.hideBtn?0.001f:self.padding);
    if (!lastView) {
        btnView.frame = CGRectMake(self.leftOffset, 0, viewWidth+marginX*2, self.height);
    }else{
        if (CGRectGetMaxX(lastView.frame) + viewWidth + self.fixOffset +marginX*2 > self.width) {
            btnView.frame = CGRectMake(self.leftOffset, CGRectGetMaxY(lastView.frame)+marginY, viewWidth+marginX*2, self.height);
        }else{
            btnView.frame = CGRectMake(CGRectGetMaxX(lastView.frame)+self.fixOffset, lastView.frame.origin.y, viewWidth+marginX*2, self.height);
        }
    }
    [view addSubview:btnView];
    
    [self setStyleUIWithView:btnView withWidth:labelWidth withTitle:title];
    
    //遮罩层
    UIView *temp =  [UIView new];
    [btnView addSubview:temp];
    temp.frame = btnView.bounds;
    
    
    [self setRadio:backRadio withID:btnView];
    
    return btnView;
    
}

/*
 * 根据type构建不同标签视图中的文本和按钮
 *
 * @param  title        文本内如
 * @param  btnView      父视图
 * @param  labelWidth   文本宽度
 *
 */
- (void)setStyleUIWithView:(UIView*)btnView withWidth:(CGFloat)labelWidth withTitle:(NSString*)title{
    switch (self.type) {
        case BtnTypeNornal:{
            UIButton *imageBtn = [self getBtn];
            [btnView addSubview:imageBtn];
            imageBtn.frame = CGRectMake(marginX, (self.height-self.btnHeight)/2, (self.hideBtn?0.001f:self.btnWidth), self.btnHeight);
            
            UILabel *label = [self getLabel:title];
            [btnView addSubview:label];
            label.frame = CGRectMake(CGRectGetMaxX(imageBtn.frame)+(self.hideBtn?0.001f:self.padding), 0, labelWidth, self.btnHeight+10);
            label.center = CGPointMake(label.center.x, imageBtn.center.y);
        }
            break;
        case BtnTypeImageRight:{
            UIButton *imageBtn = [self getBtn];
            [btnView addSubview:imageBtn];
            
            UILabel *label = [self getLabel:title];
            [btnView addSubview:label];
            label.frame = CGRectMake(marginX, 0, labelWidth, self.btnHeight+10);
            imageBtn.frame = CGRectMake(CGRectGetMaxX(label.frame)+(self.hideBtn?0.001f:self.padding), (self.height-self.btnHeight)/2, (self.hideBtn?0.001f:self.btnWidth), self.btnHeight);
            label.center = CGPointMake(label.center.x, imageBtn.center.y);
        }
        default:
            break;
    }
}

/*
 * 根据type更新不同标签视图中的文本和按钮
 *
 * @param  imageBtn     按钮
 * @param  label        文本
 * @param  labelWidth   文本宽度
 *
 */
- (void)updateUIWithTypeWithBtnView:(UIView*)imageBtn labelView:(UIView*)label withWidth:(CGFloat)labelWidth{
    
    switch (self.type) {
        case BtnTypeNornal:{
            imageBtn.frame = CGRectMake(marginX, (self.height-self.btnHeight)/2, self.hideBtn?0.001f:self.btnWidth, self.btnHeight);
            label.frame = CGRectMake(CGRectGetMaxX(imageBtn.frame)+(self.hideBtn?0.001f:self.padding), 0, labelWidth, self.btnHeight+10);
            label.center = CGPointMake(label.center.x, imageBtn.center.y);
        }
            break;
        case BtnTypeImageRight:{
            label.frame = CGRectMake(marginX, 0, labelWidth, self.btnHeight+10);
            imageBtn.frame = CGRectMake(CGRectGetMaxX(label.frame)+(self.hideBtn?0.001f:(self.hideBtn?0.001f:self.padding)), (self.height-self.btnHeight)/2, (self.hideBtn?0.001f:self.btnWidth), self.btnHeight);
            label.center = CGPointMake(label.center.x, imageBtn.center.y);
        }
        default:
            break;
    }
    
}

/*
 * 构建文本
 *
 * @param  label        文本
 *
 */
- (UILabel*)getLabel:(NSString*)title{
    UILabel *label = [UILabel new];
    label.textAlignment = NSTextAlignmentLeft;
    label.text = title;
    label.tag = 111;
    label.font = [UIFont systemFontOfSize:self.font];
    label.textColor = self.textColor;
    return label;
}

/*
 * 构建按钮
 */
- (UIButton*)getBtn{
    UIButton *imageBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [self setRadio:self.btnHeight/2 withID:imageBtn];
    imageBtn.tag = 222;
    UIImage *nornalImage = [UIImage imageNamed:self.nornalImage];
    UIImage *selectImage = [UIImage imageNamed:self.selectImage];
    [imageBtn setImage:nornalImage forState:UIControlStateNormal];
    [imageBtn setImage:selectImage forState:UIControlStateSelected];
    return imageBtn;
}

/*
 * 标签点击方法
 */
- (void)tapAction:(UITapGestureRecognizer*)tap{
    [self selectView:tap.view];
}

/*
 * 标签点击具体实现方法
 */
- (void)selectView:(UIView*)selectBtn{
    
    for (UIView *btnView in self.viewArr) {
        UIButton *btn = (UIButton*)[btnView viewWithTag:222];
        UILabel *label = (UILabel*)[btnView viewWithTag:111];
        NSDictionary *dic = @{@"num":@(btnView.tag),@"text":label.text};
        if (btnView==selectBtn) {
            if (self.cancelSelect) {
                if ([btn isSelected]) {
                    btn.selected = NO;
                    label.textColor = self.textColor;
                    btnView.backgroundColor = self.btnViewColor;
                }else{
                    btn.selected = YES;
                    label.textColor = self.selectTextColor;
                    btnView.backgroundColor = self.selectBackColor;
                }
            }else{
                btn.selected = YES;
                label.textColor = self.selectTextColor;
                btnView.backgroundColor = self.selectBackColor;
            }
            if (self.checkBox) {
                if ([btn isSelected]) {
                    if (![self.handBlockArr containsObject:dic]) {
                        [self.handBlockArr addObject:dic];
                    }
                }else{
                    if ([self.handBlockArr containsObject:dic]) {
                        [self.handBlockArr removeObject:dic];
                    }
                }
            }else{
                if ([btn isSelected]) {
                    self.blockData = label.text;
                    if (self.handBlock) {
                        self.handBlock(self.blockData);
                    }
                }else{
                    self.blockData = @"";
                    if (self.handBlock) {
                        self.handBlock(self.blockData);
                    }
                }
            }
            
            
        }
          else{
              
            if (!self.checkBox) {
                label.textColor = self.textColor;
                btn.selected = NO;
                btnView.backgroundColor = self.btnViewColor;
                
            }else{
                if ([btn isSelected]) {
                    if (![self.handBlockArr containsObject:dic]) {
                        [self.handBlockArr addObject:dic];
                    }
                }
            }
    }
    }
    
    if (self.checkBox) {
        [self.handBlockArr sortUsingComparator:^NSComparisonResult(NSDictionary*  _Nonnull obj1, NSDictionary*  _Nonnull obj2) {
                return [obj1[@"num"] integerValue]>[obj2[@"num"] integerValue];
        }];
        NSMutableArray *blockArr = [NSMutableArray new];
        for (NSDictionary *tempDic in self.handBlockArr) {
            [blockArr addObject:tempDic[@"text"]];
        }
        if (blockArr.count==0) {
            self.blockData = @"";
        }else if(blockArr.count==1){
            self.blockData = blockArr[0];
        }else{
            self.blockData = [NSArray arrayWithArray:blockArr];
        }
        if (self.handBlock) {
            self.handBlock(self.blockData);
        }
    }
}

/*
 * 设置圆角
 *
 * @param  radio    圆角大小
 * @param  view     视图
 *
 */
- (void)setRadio:(CGFloat)radio withID:(UIView*)view{
    view.layer.cornerRadius = radio;
    view.layer.masksToBounds = YES;
}

/*
 * 根据宽度求高度
 *
 * @param  text     内容
 * @param  width    宽度
 * @param  font     字号
 *
 */
- (CGFloat)getLabelHeightWithText:(NSString *)text width:(CGFloat)width font: (CGFloat)font
{
    CGRect rect = [text boundingRectWithSize:CGSizeMake(width, MAXFLOAT) options:NSStringDrawingUsesLineFragmentOrigin attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:font]} context:nil];
    
    return rect.size.height;
}

/*
 * 根据高度度求宽度
 *
 * @param  text     内容
 * @param  height   高度
 * @param  font     字号
 *
 */
- (CGFloat)getWidthWithText:(NSString *)text height:(CGFloat)height font:(CGFloat)font{
    
    CGRect rect = [text boundingRectWithSize:CGSizeMake(MAXFLOAT, height)
                                     options:NSStringDrawingUsesLineFragmentOrigin
                                  attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:font]}
                                     context:nil];
    return rect.size.width;
    
}


- (NSString *)nornalImage{
    if (!_nornalImage) {
        _nornalImage = @"list_wgs_2";
    }
    return _nornalImage;
}

- (void)setNornalImage:(NSString *)nornalImage{
    _nornalImage = nornalImage;
    for (UIView *btnView in self.viewArr) {
        UIButton *imageBtn = (UIButton*)[btnView viewWithTag:222];
        UIImage *nornalImage = [UIImage imageNamed:_nornalImage];
        [imageBtn setImage:nornalImage forState:UIControlStateNormal];
    }
}

- (NSString *)selectImage{
    if (!_selectImage) {
        _selectImage = @"list_ygs_1";
    }
    return _selectImage;
}

- (void)setSelectImage:(NSString *)selectImage{
    _selectImage = selectImage;
    for (UIView *btnView in self.viewArr) {
        UIButton *imageBtn = (UIButton*)[btnView viewWithTag:222];
        UIImage *selectImage = [UIImage imageNamed:_selectImage];
        [imageBtn setImage:selectImage forState:UIControlStateSelected];
    }
}

- (CGFloat)font{
    if (!_font) {
        _font = 13.0f;
    }
    return _font;
}

- (void)setFont:(CGFloat)font{
    _font = font;
    
    for (UIView *btnView in self.viewArr) {
        UILabel *label = (UILabel*)[btnView viewWithTag:111];
        label.font = [UIFont systemFontOfSize:_font];
    }
    [self updateSubview];
}

- (UIColor *)textColor{
    if (!_textColor) {
        _textColor = [UIColor lightGrayColor];
    }
    return _textColor;
}

- (UIColor *)selectTextColor{
    if (!_selectTextColor) {
        _selectTextColor = [UIColor blackColor];
    }
    return _selectTextColor;
}

- (void)setTextColor:(UIColor *)textColor{
    _textColor = textColor;
    for (UIView *btnView in self.viewArr) {
        UILabel *label = (UILabel*)[btnView viewWithTag:111];
        label.textColor = _textColor;
    }
}

- (CGFloat)padding{
    if (!_padding) {
        _padding = 5.0f;
    }
    return _padding;
}

- (void)setPadding:(CGFloat)padding{
    
    _padding = padding;
    [self updateSubview];
}

- (CGFloat)leftOffset{
    if (!_leftOffset) {
        _leftOffset = 0;
    }
    return _leftOffset;
}

- (void)setLeftOffset:(CGFloat)leftOffset{
    _leftOffset = leftOffset;
    [self updateSubview];
}

- (CGFloat)rightOffset{
    if (!_rightOffset) {
        _rightOffset = 0;
    }
    return _rightOffset;
}

- (void)setRightOffset:(CGFloat)rightOffset{
    _rightOffset = rightOffset;
    [self updateSubview];
}

- (CGFloat)fixOffset{
    if (!_fixOffset) {
        _fixOffset = 10.0f;
    }
    return _fixOffset;
}

- (void)setFixOffset:(CGFloat)fixOffset{
    _fixOffset = fixOffset;
     [self updateSubview];
}


- (void)setCancelFirstSelect:(BOOL)cancelFirstSelect{
    _cancelFirstSelect = cancelFirstSelect;
    for (UIView *btnView in self.viewArr) {
        if (btnView.tag==1000) {
            UIButton *imageBtn = (UIButton*)[btnView viewWithTag:222];
            UILabel *label = (UILabel*)[btnView viewWithTag:111];
            NSDictionary *dic = @{@"num":@(btnView.tag),@"text":label.text};
            if (cancelFirstSelect) {
               imageBtn.selected = NO;
                label.textColor = self.textColor;
                btnView.backgroundColor = self.btnViewColor;
                if (self.checkBox) {
                    
                    if ([self.handBlockArr containsObject:dic]) {
                        [self.handBlockArr removeObject:dic];
                    }
                    if (self.handBlockArr.count==0) {
                        self.blockData = @"";
                        if (self.handBlock) {
                            self.handBlock(self.blockData);
                        }
                        
                    }else{
                        NSLog(@"出错了");
                    }
                }else{
                    self.blockData = @"";
                    if (self.handBlock) {
                        self.handBlock(self.blockData);
                    }
                }
            }else{
               imageBtn.selected = YES;
               label.textColor = self.selectTextColor;
               btnView.backgroundColor = self.selectBackColor;
                if (self.checkBox) {
                    if (![self.handBlockArr containsObject:dic]) {
                        [self.handBlockArr addObject:dic];
                    }
                    self.blockData = label.text;
                    if (self.handBlock) {
                        self.handBlock(self.blockData);
                    }
                }else{
                    self.blockData = label.text;
                    if (self.handBlock) {
                        self.handBlock(self.blockData);
                    }
                }
            }
            break;
        }
    }
}

- (CGFloat)btnWidth{
    if (!_btnWidth) {
        _btnWidth = 20;
    }
    return _btnWidth;
}

- (void)setBtnWidth:(CGFloat)btnWidth{
    _btnWidth = btnWidth;
     [self updateSubview];
}

- (CGFloat)btnHeight{
    if (!_btnHeight) {
        _btnHeight = 20;
    }
    return _btnHeight;
}

- (void)setBtnHeight:(CGFloat)btnHeight{
    _btnHeight = btnHeight;
     [self updateSubview];
}


- (UIColor *)btnViewColor{
    if (!_btnViewColor) {
        _btnViewColor = [UIColor yellowColor];
    }
    return _btnViewColor;
}

- (void)setBtnViewColor:(UIColor *)btnViewColor{
    _btnViewColor = btnViewColor;
    for (UIView *btnView in self.viewArr) {
        UIButton *btn = [btnView viewWithTag:222];
        if (![btn isSelected]) {
            btnView.backgroundColor = _btnViewColor;
        }
    }
}

- (void)setHideBtn:(BOOL)hideBtn{
    _hideBtn = hideBtn;
    if (hideBtn) {
        marginX = 10;
    }else{
        marginX = 5;
    }
    [self updateSubview];
}

- (void)setCheckBox:(BOOL)checkBox{
    _checkBox = checkBox;
    self.cancelSelect = YES;
}

- (void)setCancelSelect:(BOOL)cancelSelect{
    if (self.checkBox) {
        _cancelSelect = YES;
    }else{
        _cancelSelect = cancelSelect;
    }
}

- (id)data{
    if (!_data) {
        
    }
    return _data;
}

- (void)setData:(id)data{
    _data = data;
    
    if ([data isKindOfClass:[NSArray class]]||[data isKindOfClass:[NSMutableArray class]]||[data isKindOfClass:[NSString class]]) {
        [self insertViewToArrWithData:data];
    }else{
        NSLog(@"请输入规范的数据");
    }

}

- (UIColor *)selectBackColor{
    if (!_selectBackColor) {
        _selectBackColor = [UIColor orangeColor];
    }
    return _selectBackColor;
}

- (void)setSelectTextColor:(UIColor *)selectTextColor{
    _selectTextColor = selectTextColor;
    for (UIView *btnView in self.viewArr) {
        UIButton *btn = [btnView viewWithTag:222];
        UILabel *label = (UILabel*)[btnView viewWithTag:111];
        if ([btn isSelected]) {
            label.textColor = selectTextColor;
        }
    }
}

- (void)setSelectBackColor:(UIColor *)selectBackColor{
    _selectBackColor = selectBackColor;
    for (UIView *btnView in self.viewArr) {
        UIButton *btn = [btnView viewWithTag:222];
        if ([btn isSelected]) {
            btnView.backgroundColor = selectBackColor;
        }
    }
}

- (CGFloat)x{
    if (!_x) {
        _x = self.frame.origin.x;
    }
    return _x;
}

- (CGFloat)y{
    if (!_y) {
        _y = self.frame.origin.y;
    }
    return _y;
}

- (CGFloat)width{
    if (!_width) {
        _width = self.frame.size.width;
    }
    return _width;
}


- (CGFloat)height{
    if (!_height) {
        _height = self.frame.size.height;
    }
    return _height;
}

- (NSMutableArray *)handBlockArr{
    if (!_handBlockArr) {
        _handBlockArr = [NSMutableArray new];
    }
    return _handBlockArr;
}


- (NSMutableArray *)viewArr{
    if (!_viewArr) {
        _viewArr = [NSMutableArray new];
    }
    return _viewArr;
}

@end
